version: '3.8'

x-cache-from:
  - &app-cache-from
    cache_from:
      - php:8.0-fpm

services:


  db:
    container_name: postgres
    image: postgres:13-alpine
    restart: always
    environment:
        POSTGRES_PASSWORD: password
        POSTGRES_DB: db
        POSTGRES_USER: postgres
    volumes:
       - db-data:/var/lib/postgresql/data:rw
    ports:
      - target: 5432
        published: 5432
        protocol: tcp
    
  pgadmin:
    container_name: pgAdmin
    image: dpage/pgadmin4
    restart: always
    environment:
      PGADMIN_DEFAULT_EMAIL: admin@admin.com
      PGADMIN_DEFAULT_PASSWORD: root
    ports:
    - 5050:80
    depends_on:
      - db

  # adminer:
  #   image: adminer
  #   restart: always
  #   environment:
  #     ADMINER_DESIGN: pepa-linha
  #     ADMINER_PLUGINS: tables-filter tinymce
  #     ADMINER_DEFAULT_SERVER: db
  #   ports:
  #     - "8080:8080"
  #   depends_on:
  #     - db


  php:
    container_name: php
    image: php:8.0-fpm
    build:
      context: ./docker/php-fpm
      <<: *app-cache-from
    depends_on:
      - db
    environment:
      - APP_ENV=${APP_ENV}
      - APP_SECRET=${APP_SECRET}
      - DATABASE_URL=${DATABASE_URL}
    healthcheck:
      interval: 10s
      timeout: 3s
      retries: 3
      start_period: 30s
    volumes:
      - ./:/var/www
      - app-cache:/var/www/var

  nginx:
    container_name: nginx
    build:
      context: ./docker/nginx
    volumes:
      - ./:/var/www
      - ./docker/nginx/nginx.conf:/etc/nginx/nginx.conf
      - ./docker/nginx/sites/:/etc/nginx/sites-available
      - ./docker/nginx/conf.d/:/etc/nginx/conf.d
      - ./docker/logs:/var/log
    depends_on:
      - php
      - mailcatcher
    ports:
      - "80:80"
      - "443:443"

  mailcatcher:
    container_name: MailCatcher
    image: schickling/mailcatcher
    ports:
      - "1080:1080"


volumes:
  db-data: {}
  app-cache: {}
